/****************************************************************************
	$Header: /Dev/Tin3/InstallDir/Tix/TixDefs.h 12    20-08-06 11:09 Ron $

	Copyright (c) 1990-2005 Tarma Software Research. All rights reserved.

	Project:	Tarma Installer
	Author:		Ron van der Wal
	Created:	23-10-2002 11:28

	Tarma Installer extension DLL base declarations.

	NOTE: For best results, view with tab stops set at every 4 positions.

	THE CONTENTS OF THIS DOCUMENT ARE CONFIDENTIAL AND PROPRIETARY TO
	TARMA SOFTWARE RESEARCH PTY LTD, AND MAY NOT BE REPRODUCED, PUBLISHED,
	OR DISCLOSED TO OTHERS WITHOUT COMPANY AUTHORISATION.

	Use of this document is allowed to registered users of Tarma Installer
	and solely for the purpose of creating Tarma Installer Extension DLLs.
****************************************************************************/

#ifndef __TIXDEFS_H
#define __TIXDEFS_H

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

//===========================================================================
// Build version and model
//===========================================================================

//-----	Specification version

#define __TIXVER__		3000	// Encoded as (major * 1000) + minor

#ifndef RC_INVOKED		// Not for resource compilers

//-----	Call models

#define TIXAPI			__stdcall
#define TIXCALLAPI		__stdcall

//-----	Build-specific modifiers; _TIX_BUILD is defined during extension
//		DLL builds (see TixDll.cpp)

#ifdef _TIX_BUILD
#define _TIXENTRY		__declspec(dllexport)
#else
#define _TIXENTRY		__declspec(dllimport)
#endif


//===========================================================================
// General definitions
//===========================================================================

// Return the number of elements in an array
#ifndef __countof
#define __countof(x)			(sizeof(x) / sizeof((x)[0]))
#endif

// Suppress "unused" parameter/variable warnings
#ifndef UNUSED
#define UNUSED(x)				((void)(x))
#endif

//---------------------------------------------------------------------------
// Character and string types
//
// Regardless of the build mode, we make sure that *all* char types are
// UNSIGNED. This prevents nasty errors during string processing of chars
// that have their high bit set, including MBCS and UTF-8 parsing.
//
// To get this right without conflicts with the Win32 SDK, we make sure
// that plain 'char' is unsigned. That way, we don't have to typedef
// ACHAR as unsigned char and avoid a barrage of typecasts.

#ifndef _CHAR_UNSIGNED
#error Default char type not unsigned - use /J
#endif

// Base character types
typedef char			ACHAR;			// ANSI and UTF8
typedef unsigned short	WCHAR;			// Unicode

// Build-mode dependent definitions
#ifdef _UNICODE
typedef WCHAR			TCHAR;
#define __F(x)			x ## W
#define __T(x)			L ## x
#else
typedef ACHAR			TCHAR;
#define __F(x)			x ## A
#define __T(x)			x
#endif

#define _F(x)			__F(x)
#define _T(x)			__T(x)
#define _TEXT(x)		__T(x)
#define __W(x)			L ## x
#define _W(x)			__W(x)

// MBCS/SBCS/Unicode macros
#if defined(_MBCS) && defined(_UNICODE)
#error _MBCS and _UNICODE cannot both be defined
#endif

#ifdef _MBCS
#define	_CHARNEXT(pszPos)				CharNext(pszPos)
#define	_CHARPREV(pszStr, pszPos)		CharPrev((pszStr), (pszPos))
#define	_CHARPREVX(pszStr, pszPos)		CharPrev((pszStr), (pszPos))
#else
#define	_CHARNEXT(pszPos)				((pszPos) + 1)
#define	_CHARPREV(pszStr, pszPos)		((pszPos) > (pszStr) ? ((pszPos) - 1) : (pszStr))
#define	_CHARPREVX(pszStr, pszPos)		((pszPos) - 1)
#endif

#ifdef __cplusplus
}		// extern "C"
#endif

#endif	// RC_INVOKED
#endif	// __TIXDEFS_H
