/****************************************************************************
	$Header: /Dev/Tin3/InstallDir/Tix/TixHandlers.h 2     10-12-05 12:16 Ron $

	Copyright (c) 1990-2005 Tarma Software Research. All rights reserved.

	Project:	Tarma Installer
	Author:		Ron van der Wal
	Created:	01-12-2005 09:58

	Declaration of the TIX handlers.

	NOTE: For best results, view with tab stops set at every 4 positions.

	THE CONTENTS OF THIS DOCUMENT ARE CONFIDENTIAL AND PROPRIETARY TO
	TARMA SOFTWARE RESEARCH PTY LTD, AND MAY NOT BE REPRODUCED, PUBLISHED,
	OR DISCLOSED TO OTHERS WITHOUT COMPANY AUTHORISATION.

	Use of this document is allowed to registered users of Tarma Installer
	and solely for the purpose of creating Tarma Installer Extension DLLs.
****************************************************************************/

#ifndef __TIXHANDLERS_H
#define __TIXHANDLERS_H

#pragma once

#ifndef __TIX_H
#include "Tix.h"		// Message declarations etc.
#endif

#ifdef __cplusplus
extern "C" {
#endif

//===========================================================================
// Handler function declarations for each TIXMSG_xxx value.
//===========================================================================

//---------------------------------------------------------------------------
// Signature of _TixOnHandle() functions

typedef BOOL (TIXAPI *_fTixOnHandleA)(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
typedef BOOL (TIXAPI *_fTixOnHandleW)(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

#ifdef _UNICODE
#define _fTixOnHandle _fTixOnHandleW
#else
#define _fTixOnHandle _fTixOnHandleA
#endif

//---------------------------------------------------------------------------
// Prototypes of handler functions

//-----
// TIXMSG_INITIALIZE

BOOL TIXAPI _TixOnInitializeA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnInitializeW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_TERMINATE

BOOL TIXAPI _TixOnTerminateA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnTerminateW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_CHECK_REQUIREMENTS

BOOL TIXAPI _TixOnCheckRequirementsA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnCheckRequirementsW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_INIT_REGISTRATION

BOOL TIXAPI _TixOnInitRegistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] cTixRegistrationInfo*
);
BOOL TIXAPI _TixOnInitRegistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_CHECK_REGISTRATION

BOOL TIXAPI _TixOnCheckRegistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] cTixRegistrationInfo*
);
BOOL TIXAPI _TixOnCheckRegistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_APPLY_REGISTRATION

BOOL TIXAPI _TixOnApplyRegistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] cTixRegistrationInfo*
);
BOOL TIXAPI _TixOnApplyRegistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_PROCESSING

BOOL TIXAPI _TixOnStartProcessingA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartProcessingW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_PROCESSING

BOOL TIXAPI _TixOnEndProcessingA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndProcessingW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_ABORT_PROCESSING

BOOL TIXAPI _TixOnAbortProcessingA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnAbortProcessingW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_INIT_OPTIONS

BOOL TIXAPI _TixOnInitOptionsA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnInitOptionsW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_CHECK_OPTIONS

BOOL TIXAPI _TixOnCheckOptionsA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnCheckOptionsW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_FILE_INSTALL

BOOL TIXAPI _TixOnStartFileInstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartFileInstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_FILE_INSTALL

BOOL TIXAPI _TixOnEndFileInstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndFileInstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_FILE_REGISTRATION

BOOL TIXAPI _TixOnStartFileRegistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartFileRegistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_FILE_REGISTRATION

BOOL TIXAPI _TixOnEndFileRegistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndFileRegistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_SHORTCUT_INSTALL

BOOL TIXAPI _TixOnStartShortcutInstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartShortcutInstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_SHORTCUT_INSTALL

BOOL TIXAPI _TixOnEndShortcutInstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndShortcutInstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_SYSTEM_INSTALL

BOOL TIXAPI _TixOnStartSystemInstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartSystemInstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_SYSTEM_INSTALL

BOOL TIXAPI _TixOnEndSystemInstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndSystemInstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_FILE_REMOVAL

BOOL TIXAPI _TixOnStartFileRemovalA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartFileRemovalW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_FILE_REMOVAL

BOOL TIXAPI _TixOnEndFileRemovalA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndFileRemovalW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_FILE_UNREGISTRATION

BOOL TIXAPI _TixOnStartFileUnregistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartFileUnregistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_FILE_UNREGISTRATION

BOOL TIXAPI _TixOnEndFileUnregistrationA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndFileUnregistrationW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_SHORTCUT_REMOVAL

BOOL TIXAPI _TixOnStartShortcutRemovalA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartShortcutRemovalW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_SHORTCUT_REMOVAL

BOOL TIXAPI _TixOnEndShortcutRemovalA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndShortcutRemovalW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_START_SYSTEM_REMOVAL

BOOL TIXAPI _TixOnStartSystemRemovalA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnStartSystemRemovalW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_END_SYSTEM_REMOVAL

BOOL TIXAPI _TixOnEndSystemRemovalA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnEndSystemRemovalW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//-----
// TIXMSG_CHECK_UNINSTALL

BOOL TIXAPI _TixOnCheckUninstallA(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeA *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);
BOOL TIXAPI _TixOnCheckUninstallW(
	cTixMessage *pMessage,		// [In] Message parameters
	iTixRuntimeW *pTixRuntime,	// [In] Runtime engine interface
	void *pExtra				// [In,opt] Additional data
);

//---------------------------------------------------------------------------
// Unicode/ANSI names

#ifdef _UNICODE
#define _TixOnInitialize _TixOnInitializeW
#define _TixOnTerminate _TixOnTerminateW
#define _TixOnCheckRequirements _TixOnCheckRequirementsW
#define _TixOnInitRegistration _TixOnInitRegistrationW
#define _TixOnCheckRegistration _TixOnCheckRegistrationW
#define _TixOnApplyRegistration _TixOnApplyRegistrationW
#define _TixOnStartProcessing _TixOnStartProcessingW
#define _TixOnEndProcessing _TixOnEndProcessingW
#define _TixOnAbortProcessing _TixOnAbortProcessingW
#define _TixOnInitOptions _TixOnInitOptionsW
#define _TixOnCheckOptions _TixOnCheckOptionsW
#define _TixOnStartFileInstall _TixOnStartFileInstallW
#define _TixOnEndFileInstall _TixOnEndFileInstallW
#define _TixOnStartFileRegistration _TixOnStartFileRegistrationW
#define _TixOnEndFileRegistration _TixOnEndFileRegistrationW
#define _TixOnStartShortcutInstall _TixOnStartShortcutInstallW
#define _TixOnEndShortcutInstall _TixOnEndShortcutInstallW
#define _TixOnStartSystemInstall _TixOnStartSystemInstallW
#define _TixOnEndSystemInstall _TixOnEndSystemInstallW
#define _TixOnStartFileRemoval _TixOnStartFileRemovalW
#define _TixOnEndFileRemoval _TixOnEndFileRemovalW
#define _TixOnStartFileUnregistration _TixOnStartFileUnregistrationW
#define _TixOnEndFileUnregistration _TixOnEndFileUnregistrationW
#define _TixOnStartShortcutRemoval _TixOnStartShortcutRemovalW
#define _TixOnEndShortcutRemoval _TixOnEndShortcutRemovalW
#define _TixOnStartSystemRemoval _TixOnStartSystemRemovalW
#define _TixOnEndSystemRemoval _TixOnEndSystemRemovalW
#define _TixOnCheckUninstall _TixOnCheckUninstallW
#else
#define _TixOnInitialize _TixOnInitializeA
#define _TixOnTerminate _TixOnTerminateA
#define _TixOnCheckRequirements _TixOnCheckRequirementsA
#define _TixOnInitRegistration _TixOnInitRegistrationA
#define _TixOnCheckRegistration _TixOnCheckRegistrationA
#define _TixOnApplyRegistration _TixOnApplyRegistrationA
#define _TixOnStartProcessing _TixOnStartProcessingA
#define _TixOnEndProcessing _TixOnEndProcessingA
#define _TixOnAbortProcessing _TixOnAbortProcessingA
#define _TixOnInitOptions _TixOnInitOptionsA
#define _TixOnCheckOptions _TixOnCheckOptionsA
#define _TixOnStartFileInstall _TixOnStartFileInstallA
#define _TixOnEndFileInstall _TixOnEndFileInstallA
#define _TixOnStartFileRegistration _TixOnStartFileRegistrationA
#define _TixOnEndFileRegistration _TixOnEndFileRegistrationA
#define _TixOnStartShortcutInstall _TixOnStartShortcutInstallA
#define _TixOnEndShortcutInstall _TixOnEndShortcutInstallA
#define _TixOnStartSystemInstall _TixOnStartSystemInstallA
#define _TixOnEndSystemInstall _TixOnEndSystemInstallA
#define _TixOnStartFileRemoval _TixOnStartFileRemovalA
#define _TixOnEndFileRemoval _TixOnEndFileRemovalA
#define _TixOnStartFileUnregistration _TixOnStartFileUnregistrationA
#define _TixOnEndFileUnregistration _TixOnEndFileUnregistrationA
#define _TixOnStartShortcutRemoval _TixOnStartShortcutRemovalA
#define _TixOnEndShortcutRemoval _TixOnEndShortcutRemovalA
#define _TixOnStartSystemRemoval _TixOnStartSystemRemovalA
#define _TixOnEndSystemRemoval _TixOnEndSystemRemovalA
#define _TixOnCheckUninstall _TixOnCheckUninstallA
#endif


#ifdef __cplusplus
}		// extern "C"
#endif

#endif	// __TIXHANDLERS_H
