/****************************************************************************
	$Header: /Dev/Tin3/Source/WebUpdate/TWUDefs.h 9     7/02/07 17:05 Dave $

	Copyright (c) 1990-2005 Tarma Software Research. All rights reserved.

	Project:	Tarma Installer
	Author:		Ron van der Wal
	Created:	07-08-2004 17:50

	Tarma WebUpdate base declarations.

	NOTE: For best results, view with tab stops set at every 4 positions.

	THE CONTENTS OF THIS DOCUMENT ARE CONFIDENTIAL AND PROPRIETARY TO
	TARMA SOFTWARE RESEARCH PTY LTD, AND MAY NOT BE REPRODUCED, PUBLISHED,
	OR DISCLOSED TO OTHERS WITHOUT COMPANY AUTHORISATION.

	Use of this document is allowed to registered users of Tarma Installer
	and solely for the purpose of creating applications that are
	compatible with the Tarma Installer WebUpdate functionality.
****************************************************************************/

#ifndef __TARMA_TWUDEFS_H
#define __TARMA_TWUDEFS_H

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

//===========================================================================
// Build version and model
//===========================================================================

//-----	Specification version

#define __TWUVER__		3000	// Encoded as (major * 1000) + minor

#ifndef RC_INVOKED		// Not for resource compilers

//-----	Call models

#define TWUAPI			__stdcall

//-----	Build-specific modifiers. _TWU_BUILD is defined to build the
//		WebUpdate DLL; it must be undefined for client builds.

#ifdef _TWU_BUILD
#define _TWUENTRY		__declspec(dllexport)
#else
#define _TWUENTRY		__declspec(dllimport)

// Make sure that clients link to the correct import library
#if defined(_WIN64)
	// Win64 builds
	#error Tarma WebUpdate not available for Win64 yet
#elif defined(_UNICODE)
	// Win32 Unicode builds
	#ifdef _DEBUG
	#pragma comment(lib, "TWUNTD.lib")
	#else
	#pragma comment(lib, "TWUNT.lib")
	#endif
#else
	// Win32 ANSI builds
	#ifdef _DEBUG
	#pragma comment(lib, "TWU32D.lib")
	#else
	#pragma comment(lib, "TWU32.lib")
	#endif
#endif	// Platforms

#endif	// _TWU_BUILD

//===========================================================================
// General definitions
//===========================================================================

// Return the number of elements in an array
#ifndef __countof
#define __countof(x)			(sizeof(x) / sizeof((x)[0]))
#endif

// Suppress "unused" parameter/variable warnings
#ifndef UNUSED
#define UNUSED(x)				((void)(x))
#endif

//---------------------------------------------------------------------------
// Character and string types

// Base character types
typedef char			ACHAR;			// ANSI and UTF8
typedef unsigned short	WCHAR;			// Unicode

// Build-mode dependent definitions
#ifdef _UNICODE
typedef WCHAR			TCHAR;
#define __T(x)			L ## x
#else
typedef ACHAR			TCHAR;
#define __T(x)			x
#endif

#define _T(x)			__T(x)
#define _TEXT(x)		__T(x)
#define __W(x)			L ## x
#define _W(x)			__W(x)


#ifdef __cplusplus
}		// extern "C"
#endif

#endif	// RC_INVOKED
#endif	// __TARMA_TWUDEFS_H
